# Django CRM Project - Contact Management Project 

## Live Demo - http://professionalcipher.pythonanywhere.com/ 
[Comment on Youtube Video if not working & i will fix it] [Installation Video](https://youtu.be/A6mTN6G-adM)

I am trying to create a Tutorial on How yo Create CRM or Contact Management System in Django. Basically this tutorial is creating while explaining video tutorial. This is the series of Django CRM Tutorial.

![Image of CRM](https://studygyaan.com/wp-content/uploads/2020/02/Django-CRM-Website.jpg)

### Setup
1. Create a folder and put all the files inside it.
2. Create a virtual environtment - `virtualenv env`
3. Activate VirtualENV - ubuntu : `source env/bin/activate` || windows : `. .\env\Scripts\activate`
4. Run requirements.txt - `pip install -r requirements.txt`
5. Run the Application - `python manage.py runserver`
6. Migrate



from django.shortcuts import render
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy
from django.views.generic import TemplateView, CreateView
from .forms import SignUpForm, UserForm, ProfileForm
from django.contrib.auth.models import User
from django.http import HttpResponseRedirect
from django.contrib import messages
from apps.userprofile.models import Profile
import cv2

class HomeView(TemplateView):
    template_name = 'common/home.html'

class DashboardView(LoginRequiredMixin, TemplateView):
    template_name = 'common/dashboard.html'
    login_url = reverse_lazy('home')
    # variables
    # distance from camera to object(face) measured
    Known_distance = 30  # Inches
    # mine is 14.3 something, measure your face width, are google it
    Known_width = 5.7  # Inches

    # Colors  >>> BGR Format(BLUE, GREEN, RED)
    GREEN = (0, 255, 0)
    RED = (0, 0, 255)
    BLACK = (0, 0, 0)
    YELLOW = (0, 255, 255)
    WHITE = (255, 255, 255)
    CYAN = (255, 255, 0)
    MAGENTA = (255, 0, 242)
    GOLDEN = (32, 218, 165)
    LIGHT_BLUE = (255, 9, 2)
    PURPLE = (128, 0, 128)
    CHOCOLATE = (30, 105, 210)
    PINK = (147, 20, 255)
    ORANGE = (0, 69, 255)

    fonts = cv2.FONT_HERSHEY_COMPLEX
    fonts2 = cv2.FONT_HERSHEY_SCRIPT_SIMPLEX
    fonts3 = cv2.FONT_HERSHEY_COMPLEX_SMALL
    fonts4 = cv2.FONT_HERSHEY_TRIPLEX
    # Camera Object
    # cap = cv2.VideoCapture(0)  # Number According to your Camera
    Distance_level = 0

    # Define the codec and create VideoWriter object
    fourcc = cv2.VideoWriter_fourcc(*"XVID")
    out = cv2.VideoWriter("./media/image/output21.mp4", fourcc, 30.0, (640, 480))

    # face detector object
    # face_detector = cv2.CascadeClassifier("haarcascade_frontalface_default.xml")
    # focal length finder function

    faceMessage=""
 
    def get_context_data(self, **kwargs):
        # Call the base implementation first to get a context
        context = super().get_context_data(**kwargs)
        # Add in a QuerySet of all the books
        print(self.request.user.id)
        context['book_list'] = self.request.user
        return context

    # def predictImage(self,request):
    #     # startStreaming()
    #     messages.error(request,'Your profile is updated successfully!')
    #     context={'filePathName':'filePathName','predictedLabel':'1'}
    #     return render(request,'dashboard.html',context) 

    def startStreaming(self):
        Distance_level = 0
        cap = cv2.VideoCapture(0)
        # cap.open(-1, cv2.CAP_DSHOW)
        # reading reference image from directory
        ref_image = cv2.imread("./media/image/Ref_image.png")

        ref_image_face_width, _, _, _ = self.face_data(ref_image, False, Distance_level)
        Focal_length_found = self.FocalLength(self.Known_distance, self.Known_width, ref_image_face_width)
        

        while True:
            _, frame = cap.read()
            # calling face_data function
            # Distance_leve =0

            face_width_in_frame, Faces, FC_X, FC_Y = self.face_data(frame, True, Distance_level)
            # finding the distance by calling function Distance finder
            for (face_x, face_y, face_w, face_h) in Faces:
                if face_width_in_frame != 0:

                    Distance = self.Distance_finder(
                        Focal_length_found,self. Known_width, face_width_in_frame
                    )
                    Distance = round(Distance, 2)
                    # Drwaing Text on the screen
                    Distance_level = int(Distance)
                    # print(Distance)
    
                    self.checkUserFocus(Distance)

                    cv2.putText(
                        frame,
                        f"Distance {Distance} Inches",
                        (face_x - 6, face_y - 6),
                        self.fonts,
                        0.5,
                        (self.BLACK),
                        2,
                    )
            cv2.imshow("frame", frame)
            self.out.write(frame)

            if cv2.waitKey(1) == ord("q"):
                break

        cap.release()
        # out.release()
        cv2.destroyAllWindows()
    

    def checkUserFocus(self,distance):
        value=distance
        print(value)
        message="Good focusing"
        if(value>30):
            message="Please focuse"
            print("long face observed")
        context={'filePathName':"message",'predictedLabel':'1'}
        # return render(request,'dashboard.html',context) 


    def FocalLength(self,measured_distance, real_width, width_in_rf_image):
        focal_length = (width_in_rf_image * measured_distance) / real_width
        return focal_length


    # distance estimation function


    def Distance_finder(self,Focal_Length, real_face_width, face_width_in_frame):
        distance = (real_face_width * Focal_Length) / face_width_in_frame
        return distance


    # face detection Fauction


    def face_data(self,image, CallOut, Distance_level):
        face_detector = cv2.CascadeClassifier("./media/image/haarcascade_frontalface_default.xml")
        face_width = 0
        face_x, face_y = 0, 0
        face_center_x = 0
        face_center_y = 0
        gray_image = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)
        faces = face_detector.detectMultiScale(gray_image, 1.3, 5)
        for (x, y, w, h) in faces:
            line_thickness = 2
            # print(len(faces))
            LLV = int(h * 0.12)
            # print(LLV)

            # cv2.rectangle(image, (x, y), (x+w, y+h), BLACK, 1)
            cv2.line(image, (x, y + LLV), (x + w, y + LLV), (self.GREEN), line_thickness)
            cv2.line(image, (x, y + h), (x + w, y + h), (self.GREEN), line_thickness)
            cv2.line(image, (x, y + LLV), (x, y + LLV + LLV), (self.GREEN), line_thickness)
            cv2.line(
                image, (x + w, y + LLV), (x + w, y + LLV + LLV), (self.GREEN), line_thickness
            )
            cv2.line(image, (x, y + h), (x, y + h - LLV), (self.GREEN), line_thickness)
            cv2.line(image, (x + w, y + h), (x + w, y + h - LLV), (self.GREEN), line_thickness)

            face_width = w
            face_center = []
            # Drwaing circle at the center of the face
            face_center_x = int(w / 2) + x
            face_center_y = int(h / 2) + y
            if Distance_level < 10:
                Distance_level = 10

            # cv2.circle(image, (face_center_x, face_center_y),5, (255,0,255), 3 )
            if CallOut == True:
                # cv2.line(image, (x,y), (face_center_x,face_center_y ), (155,155,155),1)
                cv2.line(image, (x, y - 11), (x + 180, y - 11), (self.ORANGE), 28)
                cv2.line(image, (x, y - 11), (x + 180, y - 11), (self.YELLOW), 20)
                cv2.line(image, (x, y - 11), (x + Distance_level, y - 11), (self.GREEN), 18)

                # cv2.circle(image, (face_center_x, face_center_y),2, (255,0,255), 1 )
                # cv2.circle(image, (x, y),2, (255,0,255), 1 )

            # face_x = x
            # face_y = y

        return face_width, faces, face_center_x, face_center_y

class SignUpView(CreateView):
    form_class = SignUpForm
    success_url = reverse_lazy('home')
    template_name = 'common/register.html'

from django.http import HttpResponseRedirect
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy
from .forms import UserForm, ProfileForm
from django.contrib.auth.models import User
from apps.userprofile.models import Profile

from django.contrib import messages

class ProfileView(LoginRequiredMixin, TemplateView):
    template_name = 'common/profile.html'

class ProfileUpdateView(LoginRequiredMixin, TemplateView):
    user_form = UserForm
    profile_form = ProfileForm
    template_name = 'common/profile-update.html'

    def posts(self, request):

        post_data = request.POST or None
        file_data = request.FILES or None

        user_form = UserForm(post_data, instance=request.user)
        profile_form = ProfileForm(post_data, file_data, instance=request.user.profile)

        if user_form.is_valid() and profile_form.is_valid():
            user_form.save()
            profile_form.save()
            messages.error(request, 'Your profile is updated successfully!')
            return HttpResponseRedirect(reverse_lazy('profile'))

        context = self.get_context_data(
                                        user_form=user_form,
                                        profile_form=profile_form
                                    )

        return self.render_to_response(context)     

    def get(self, request, *args, **kwargs):
        return self.posts(request, *args, **kwargs)




https://stackoverflow.com/questions/69974401/image-for-loop-in-django-template-html