from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm

from apps.userprofile.models import Profile, ProfileGenerated

class SignUpForm(UserCreationForm):

    first_name = forms.CharField(max_length=30, required=False, help_text='Optional')
    last_name = forms.CharField(max_length=30, required=False, help_text='Optional')
    email = forms.EmailField(max_length=254, help_text='Enter a valid email address')

    class Meta:
        model = User
        fields = [
            'username', 
            'first_name', 
            'last_name', 
            'email', 
            'password1', 
            'password2', 
        ]

class UserForm(forms.ModelForm):
    class Meta:
        model = User
        fields = [
            'username', 
            'first_name', 
            'last_name', 
            'email', 
        ]

class ProfileForm(forms.ModelForm):
    class Meta:
        model = Profile
        fields = [
            'bio',
            'phone_number',
            'birth_date',
            'profile_image',
            'math_marks1',
            'math_marks2',
            'math_marks3',
            'science_marks1',
            'science_marks2',
            'science_marks3',
            'english_marks1',
            'english_marks2',
            'english_marks3',
        
        ]

class ProfileGeneratedForm(forms.ModelForm):
    class Meta:
        model = ProfileGenerated
        fields = [
            'english_average',
            'maths_average',
            'science_average',
        ]