from django.shortcuts import render, redirect
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy
from django.views.generic import TemplateView, CreateView
from .forms import SignUpForm, UserForm, ProfileForm
from django.contrib.auth.models import User
from django.http import HttpResponseRedirect
from django.contrib import messages
from apps.userprofile.models import Profile
import cv2
from django.contrib.auth.decorators import login_required
import random
import speech_recognition as sr
import os
from os.path import exists
from keras.models import load_model
import pandas
from time import time
from django.core.files.storage import FileSystemStorage
from sklearn.model_selection import cross_val_score
from sklearn.model_selection import KFold
from sklearn.preprocessing import StandardScaler
from sklearn.pipeline import Pipeline
import cv2 
import argparse 
import os 
import pytesseract 
from PIL import Image 
from numpy import asarray
import matplotlib.pyplot as plt
from sklearn.model_selection import train_test_split
import pickle
import nltk
import re, sys
import spacy
from keras.models import load_model
from keras.preprocessing.image import ImageDataGenerator, img_to_array, load_img 
import datetime
import time
from tensorflow.keras.preprocessing.text import Tokenizer
from tensorflow.keras.preprocessing.sequence import pad_sequences
import moviepy.editor as mp
import subprocess
import math
import numpy as np
from keras.models import load_model
from keras.preprocessing.image import ImageDataGenerator, img_to_array, load_img 
import datetime
import time
from keras.preprocessing import image
from keras.applications.mobilenet import preprocess_input
from cv2 import *

learn_model = load_model("././media/models/alphabet_classifier.h5",compile=False)

vido_analyzer= load_model("././media/models/vido_analyzer.h5",compile=False)

corpus_texts=['home',
'day',
'best',
'language',
'life',
'slow',
'work',
'one',
'come',
'morning',
'birthday',
'learn',
'hard',
'times',
'love',
'happy',
'bank',
'good',
'bicycle',
'how',
'you',
'aeroplane',
'right',
'help',
'your',
'my',
'thank',
'sign',]
finalyzed_sentence_list=[]
learn_letters=['0',
'1',
'2',
'3',
'7',
'C',
'D','F','I','Q','R','T','U','V','W','X','Y'
]
nlp = spacy.load("en_core_web_sm")

def home(request):
    return render(request, 'common/home.html')


def adminLogin(request):
    return render(request, 'common/login.html')

def welcome(request):
    return render(request, 'common/welcome.html')

def imageToBsl(request):
    return render(request, 'common/image_to_bsl.html')

def textTo(request):
    return render(request, 'common/text_to_bsl.html')

def videoTo(request):
    return render(request, 'common/video_to.html')

def videoToText(request):
    return render(request, 'common/video_to_text.html')


def signs(request):
    img_list=[]
    for file in os.listdir('./media/letters/'):
        img_path='./media/letters/'+file
        img_list.append(img_path)
    context={'imageList':img_list }
    return render(request, 'common/signs.html',context)

    

def learning(request):
    n = random.randint(0,16)
    GlobalVal.selected_letter=learn_letters[n]
    context={'selected_letter':GlobalVal.selected_letter}
    return render(request,'common/learning.html',context) 
 

def captureImage(request):
    cam = cv2.VideoCapture(0)
 
    cv2.namedWindow("test")
    
    img_counter = 0
    
    while True:
        ret, frame = cam.read()
        if not ret:
            print("failed to grab frame")
            break
        cv2.imshow("learn BSL", frame)
    
        k = cv2.waitKey(1)
        if k%256 == 27:
            # ESC pressed
            print("Escape hit, closing...")
            break
        elif k%256 == 32:
            # SPACE pressed
            for file in os.listdir('./media/learn/'):
                img_path='./media/learn/'+file
                os.remove(img_path)
            img_name = "opencv_frame_{}.png".format(img_counter)
            cv2.imwrite('media/learn/'+img_name, frame)
            print("{} written!".format(img_name))
            img_counter += 1
    
    cam.release()
    
    cv2.destroyAllWindows()
    fileObjImageName=""
    for file in os.listdir('./media/learn/'):
                fileObjImageName='./media/learn/'+file
    letter_value,accuracy=detectSign(fileObjImageName)
    if(letter_value==GlobalVal.selected_letter):
        predictionResult="Correct Sign Detected"
        accuracy_detect="100%"
    else:
        predictionResult="Wrong Sign Detected"
        accuracy_detect="0%"
    context={'predictionResult':predictionResult ,'accuracy':accuracy_detect,'loadPredict':True}
    return render(request,'common/learning.html',context) 


def detectSign(image_path):
    img = image.load_img(image_path, target_size=(224,224))
    x = image.img_to_array(img)
    x = np.expand_dims(x, axis=0)
    x = preprocess_input(x)
    result1=learn_model.predict(x)
    list1 = result1.tolist()
    finalresult=list1[0]
    max_value = max(finalresult)
    max_index = finalresult.index(max_value)
    print(max_index)
    letter_value=""
    if(max_index==0):
        letter_value="0"
    elif(max_index==1):
        letter_value="1"
    elif(max_index==2):
        letter_value="2"
    elif(max_index==3):
        letter_value="3"
    elif(max_index==4):
        letter_value="7"
    elif(max_index==5):
        letter_value="C"
    elif(max_index==6):
        letter_value="D"
    elif(max_index==7):
        letter_value="F"
    elif(max_index==8):
        letter_value="I"
    elif(max_index==9):
        letter_value="Q"
    elif(max_index==10):
        letter_value="R"
    elif(max_index==11):
        letter_value="T"
    elif(max_index==12):
        letter_value="U"
    elif(max_index==13):
        letter_value="V"
    elif(max_index==14):
        letter_value="W"
    elif(max_index==15):
        letter_value="X"
    elif(max_index==16):
        letter_value="Y"

    return letter_value,max_value
        
 

def convertImage(request):
    fs=FileSystemStorage()
    print(request.FILES['fileImagePath'])
    fsImage=FileSystemStorage(location='media/image')

    fileObjImage=request.FILES['fileImagePath']
    for file in os.listdir('./media/image/'):
        img_path='./media/image/'+file
        os.remove(img_path)
    fileObjImageName=fsImage.save(fileObjImage.name,fileObjImage)
    fileObjImageName='./media/image/'+fileObjImageName
    imageList=processImage(fileObjImageName)
    loadBsl=True
    context={'loadBsl':loadBsl,'imageList':imageList }
    return render(request,'common/image_to_bsl.html',context) 

def convertText(request):
    sentence=request.POST.get('fileCommentPath')
    imageList=processTextInput(sentence.lower())
    loadBsl=True
    context={'loadBsl':loadBsl,'imageList':imageList }
    return render(request,'common/text_to_bsl.html',context) 


def processImage(new_path):
    text_lines = []
    text_to_word=[]
    finalyzed_list=[]
    with open('extracted_text.txt', 'w') as f:
        img = Image.open(new_path)
        text = pytesseract.image_to_string(img)
        print(text)
        f.write(text)
        text_lines.append(text.lower())

    for line in text_lines:
        if line != '\n':
            words = nltk.word_tokenize(line)
            text_to_word=words

    print(text_to_word)
    for word in text_to_word:
        for corpus_text in corpus_texts:
            print(corpus_text)
            sublist=[]
            if(word==corpus_text):
                print("equallll&&&&&&&&&")
                sublist.append(word)
                sublist.append("space")
                break
            else:
                list_of_letters = list(word)
                for single in list_of_letters:
                    sublist.append(single)
                sublist.append("space")
        finalyzed_list.append(sublist)
    print(finalyzed_list)
    imageList=findWordMatching(finalyzed_list)
    return imageList

def processTextInput(sentence):
    text_lines=[]
    finalyzed_list=[]
    text_lines.append(sentence)
    for line in text_lines:
            if line != '\n':
                words = nltk.word_tokenize(line)
                text_to_word=words

    print(text_to_word)
    for word in text_to_word:
            for corpus_text in corpus_texts:
                print(corpus_text)
                sublist=[]
                if(word==corpus_text):
                    print("equallll&&&&&&&&&")
                    sublist.append(word)
                    sublist.append("space")
                    break
                else:
                    list_of_letters = list(word)
                    for single in list_of_letters:
                        sublist.append(single)
                    sublist.append("space")
            finalyzed_list.append(sublist)
    print(finalyzed_list)
    imageList=findWordMatching(finalyzed_list)
    return imageList    


         
def findWordMatching(finalyzed_list):
    imageList=[]
    characters=['=','-',',',';',':','!',"'",'"','(',')','@','$','&','%','+']
    for single_list in finalyzed_list:
        print(single_list)
        if(len(single_list)>2 or len(single_list[0])==1):
            print("len >1")
            for letter in single_list:
                if(letter in characters):
                    path="/media/Special_Characters/"+letter+".jpg"                  
                    imageList.append(path)
                else:
                    path="/media/letters/"+letter+".png"
                    imageList.append(path)      
        else:
            if(single_list[0] in characters):
                    path="/media/Special_Characters/"+single_list[0]+".jpg"
                    imageList.append(path)
            else:
                path="/media/words/"+single_list[0]+".jpg"             
                imageList.append(path)
                path="/media/words/"+single_list[1]+".jpg"             
                imageList.append(path)
    return imageList

def processVideoSrt(request):
    fs=FileSystemStorage()
    fsImage=FileSystemStorage(location='media/srt')

    fileObjSRT=request.FILES['fileSrtPath']
    fileObjVideo=request.FILES['fileVideoPath']
    for file in os.listdir('./media/srt/'):
        img_path='./media/srt/'+file
        os.remove(img_path)
    fileObjSRTName=fsImage.save(fileObjSRT.name,fileObjSRT)
    fileObjVidName=fsImage.save(fileObjVideo.name,fileObjVideo)
    srtName='./media/srt/'+fileObjSRTName
    videoName='/media/srt/'+fileObjVidName
   
    processedSrtName=processSrtFile(srtName)
    processed_sent_list=processSrtText(processedSrtName)
    bsl_list=processSrtTextList(processed_sent_list)
    processed_video=makeVideos(bsl_list)
    videoLoaded=True
    context={'videoLoaded':videoLoaded,'originalVid':videoName,'blsVid':processed_video}
    return render(request,'common/video_to.html',context) 

def processSrtText(textFile):
    print(textFile)
    with open(textFile) as f:
        sentences = f.readlines()
    f.close()
    return sentences


def processSrtTextList(sentences):
    processed_sent_list=[]
    for sentence in sentences:
        if(len(sentence.split(" "))<=4):
            singleList=[]
            doc = nlp(sentence)
            for token in doc:
                singleDict={}
                if token.dep_ == 'nsubj' or (token.dep_ == 'ROOT' and token.pos_ == 'NOUN'):
                        target = token.text
                        singleDict={'Subject':target}
                elif (token.dep_ == 'dobj' and token.pos_ == 'NOUN') or (token.dep_ == 'compound' and token.pos_ == 'NOUN')or (token.dep_ == 'amod' and token.pos_ == 'ADJ'):
                            target = token.text
                            singleDict={'Object':target}
                elif token.pos_ == 'VERB' or token.pos_ == 'ADV':
                            target = token.text
                            singleDict={'Verb':target}                
                singleList.append(singleDict)             
            mergedDict={}
            if(len(singleList)>2):
                    for single in singleList:
                        for key, value in single.items():
                            mergedDict[key]=value
                    bsl_sent=""
                    if mergedDict.__contains__('Object'):
                        bsl_sent=mergedDict['Object']
                    if mergedDict.__contains__('Subject'):
                        bsl_sent+=" "+mergedDict['Subject']
                    if mergedDict.__contains__('Verb'):
                        bsl_sent+=" "+mergedDict['Verb']
                    print(bsl_sent)    
                    processed_sent_list.append(bsl_sent)
        else:
            processed_sent_list.append(sentence)
    print(processed_sent_list)
    return processed_sent_list
 

def makeVideos(processed_sent_list):
    clip_list=[]
    for line in processed_sent_list:
        words = nltk.word_tokenize(line)
        for word in words:
            path="./media/sign video clips/"+word+".mp4"
            print(path)
            if(exists(path)):
                clip_list.append(path)
    clips = [ mp.VideoFileClip(clip)
          for clip in clip_list ]
    concat_clip = mp.concatenate_videoclips(clips, method="compose")
    concat_clip.write_videofile("./media/srt/processed.mp4")
    return "/media/srt/processed.mp4"



def processSrtFile(srtFile):
  file_name = srtFile
  file_encoding = 'utf-8'
  with open(file_name, encoding=file_encoding, errors='replace') as f:
    lines = f.readlines()
    new_lines = clean_up(lines)
  new_file_name = file_name[:-4] + '.txt'
  with open(new_file_name, 'w') as f:
    for line in new_lines:
      f.write(line)
  return new_file_name


def is_time_stamp(l):
  if l[:2].isnumeric() and l[2] == ':':
    return True
  return False

def has_letters(line):
  if re.search('[a-zA-Z]', line):
    return True
  return False

def has_no_text(line):
  l = line.strip()
  if not len(l):
    return True
  if l.isnumeric():
    return True
  if is_time_stamp(l):
    return True
  if l[0] == '(' and l[-1] == ')':
    return True
  if not has_letters(line):
    return True
  return False

def is_lowercase_letter_or_comma(letter):
  if letter.isalpha() and letter.lower() == letter:
    return True
  if letter == ',':
    return True
  return False

def clean_up(lines):
  new_lines = []
  for line in lines[1:]:
    if has_no_text(line):
      continue
    elif len(new_lines) and is_lowercase_letter_or_comma(line[0]):
      #combine with previous line
      new_lines[-1] = new_lines[-1].strip() + ' ' + line
    else:
      #append line
      new_lines.append(line)
  return new_lines



# def learSign():


def videoInputToText(request):
    fs=FileSystemStorage()
    print(request.FILES['fileImagePath'])
    fsVideo=FileSystemStorage(location='media/video')

    fileObjVideo=request.FILES['fileImagePath']
    for file in os.listdir('./media/video/'):
        img_path='./media/video/'+file
        os.remove(img_path)
    fileObjVideoName=fsVideo.save(fileObjVideo.name,fileObjVideo)
    fileObjVideoName='./media/video/'+fileObjVideoName
    frameCapture(fileObjVideoName)
    return render(request,'common/video_to_text.html') 
    
    
def getPredictText(request):   
    detectedText=processVideo()
    print(detectedText)
    videoLoaded=True
    context={'videoLoaded':videoLoaded,'detectedText':detectedText }
    return render(request,'common/video_to_text.html',context) 

def processVideo():
    sentence=""
    for file in os.listdir('./media/videoToText/images/'):
        print(len(file))
        img_path='./media/videoToText/images/'+file
        img = image.load_img(img_path, target_size=(224,224))
        x = image.img_to_array(img)
        x = np.expand_dims(x, axis=0)
        x = preprocess_input(x)
        result1=vido_analyzer.predict(x)
        list1 = result1.tolist()
        finalresult=list1[0]
        max_value = max(finalresult)
        max_index = finalresult.index(max_value)
        print(max_index) 
        if(max_index==0):
            sentence=sentence+ " Brother"
        elif(max_index==1):
             sentence=sentence+ " GoodMorning"
        elif(max_index==2):
             sentence=sentence+ " Hello"
        elif(max_index==3):
             sentence=sentence+ " HowAreYou"
    return sentence


def get_frame_types(video_fn):
    command = 'ffprobe -v error -show_entries frame=pict_type -of default=noprint_wrappers=1'.split()
    out = subprocess.check_output(command + [video_fn]).decode()
    frame_types = out.replace('pict_type=','').split()
    return zip(range(len(frame_types)), frame_types)

def save_i_keyframes(video_fn):
    for file in os.listdir('./media/videoToText/images/'):
        img_path='./media/videoToText/images/'+file       
        os.remove(img_path)
    print(video_fn)
    frame_types = get_frame_types(video_fn)
    i_frames = [x[0] for x in frame_types if x[1]=='I']
    if i_frames:
        basename = os.path.splitext(os.path.basename(video_fn))[0]
        cap = cv2.VideoCapture(video_fn)
        for frame_no in i_frames:
            cap.set(cv2.CAP_PROP_POS_FRAMES, frame_no)
            ret, frame = cap.read()
            outname = './media/videoToText/images/_i_frame_'+str(frame_no)+'.jpg'
            cv2.imwrite(outname, frame)
            print ('Saved: '+outname)
        cap.release()
    else:
        print ('No I-frames in '+video_fn)
#delete odd frames only if count is >3


def getFrame(path,sec,count):
    vidcap = cv2.VideoCapture(path)
    vidcap.set(cv2.CAP_PROP_POS_MSEC,sec*1000)
    hasFrames,image = vidcap.read()
    if hasFrames:
        filename = './media/videoToText/images/_i_frame_' +  str(count) + ".jpg"
        cv2.imwrite(filename, image)     # save frame as JPG file
    return hasFrames


def frameCapture(path):
    for file in os.listdir('./media/videoToText/images/'):
        img_path='./media/videoToText/images/'+file
        print("removed calldddddd")
        os.remove(img_path)

    sec = 0
    frameRate = 1 #//it will capture image in each 0.5 second
    count=1
    success = getFrame(path,sec,count)
    while success:
        count = count + 1
        sec = sec + frameRate
        sec = round(sec, 2)
        success = getFrame(path,sec,count)

    for file in os.listdir('./media/videoToText/images/'):
        img_path='./media/videoToText/images/'+file
        frameNo=file.split(".")[0].split("_i_frame_")[1]     
        if(int(frameNo)%2):
            os.remove(img_path)
 
             

    # cap = cv2.VideoCapture(path)
    # frameRate = cap.get(5) #frame rate
    # x=1
    # while(cap.isOpened()):
    #     frameId = cap.get(1) #current frame number
    #     ret, frame = cap.read()
    #     if (ret != True):
    #         break
    #     if (frameId % math.floor(frameRate) == 0):
    #         filename = './media/videoToText/images/_i_frame_' +  str(int(x)) + ".jpg";x+=1
    #         cv2.imwrite(filename, frame)

    # cap.release()
    # print ("Done!")









class SignUpView(CreateView):
    form_class = SignUpForm
    success_url = reverse_lazy('home')
    template_name = 'common/register.html'

 

class GlobalVal:
    selected_letter=""

class ProfileView(LoginRequiredMixin, TemplateView):
    template_name = 'common/profile.html'

class ProfileUpdateView(LoginRequiredMixin, TemplateView):
    user_form = UserForm
    profile_form = ProfileForm
    template_name = 'common/profile-update.html'

    def post(self,request):

        post_data = request.POST or None
        file_data = request.FILES or None

        user_form = UserForm(post_data, instance=request.user)
        profile_form = ProfileForm(post_data, file_data, instance=request.user.profile)

        if user_form.is_valid() and profile_form.is_valid():
            user_form.save()
            profile_form.save()
            messages.error(request, 'Your profile is updated successfully!')
            return HttpResponseRedirect(reverse_lazy('profile'))

        context = self.get_context_data(
                                        user_form=user_form,
                                        profile_form=profile_form
                                    )

        return self.render_to_response(context)     

    def get(self,request, *args, **kwargs):
        return self.post(request, *args, **kwargs)


