from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver

from apps.common.models import  ProfileGenerated

 

 


class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    profileGenerated=models.OneToOneField(ProfileGenerated, on_delete=models.CASCADE, null=True)
    bio = models.TextField(max_length=500, blank=True)
    phone_number = models.CharField(max_length=12, blank=True)
    birth_date = models.DateField(null=True, blank=True)
    profile_image = models.ImageField(default='default-avatar.png', upload_to='users/', null=True, blank=True)
    math_marks1 = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    math_marks2 = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    math_marks3 = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    science_marks1 = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    science_marks2 = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    science_marks3 = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    english_marks1 = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    english_marks2 = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    english_marks3 = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    english_average = models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    maths_average= models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)
    science_average= models.DecimalField(null=True, blank=True,max_digits=10,decimal_places=2)



   
    def __str__(self):
        return '%s %s' % (self.user.first_name, self.user.last_name)


@receiver(post_save, sender=User)
def create_user_profile(sender, instance, created, **kwargs):
    if created:
        Profile.objects.create(user=instance)


@receiver(post_save, sender=User)
def save_user_profile(sender, instance, **kwargs):
    instance.profile.save()